# coding: utf-8

"""
    FastAPI

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist, constr
from bia_integrator_api.models.biosample_annotation import BiosampleAnnotation
from bia_integrator_api.models.model_metadata import ModelMetadata

class Biosample(BaseModel):
    """
    Biosample
    """
    context: Optional[constr(strict=True, min_length=1)] = Field('https://raw.githubusercontent.com/BioImage-Archive/bia-integrator/main/api/src/models/jsonld/1.0/SpecimenContext.jsonld', alias="@context")
    attributes: Optional[Dict[str, Any]] = Field(None, description="         When annotations are applied, the ones that have a key different than an object attribute (so they don't overwrite it) get saved here.     ")
    annotations_applied: Optional[StrictBool] = Field(False, description="         This acts as a dirty flag, with the purpose of telling apart objects that had some fields overwritten by applying annotations (so should be rejected when writing), and those that didn't.     ")
    annotations: Optional[conlist(BiosampleAnnotation)] = None
    uuid: StrictStr = Field(...)
    version: StrictInt = Field(...)
    model: Optional[ModelMetadata] = None
    title: StrictStr = Field(...)
    organism_scientific_name: StrictStr = Field(...)
    organism_common_name: StrictStr = Field(...)
    organism_ncbi_taxon: StrictStr = Field(...)
    description: StrictStr = Field(...)
    biological_entity: StrictStr = Field(...)
    experimental_variables: Optional[conlist(StrictStr)] = None
    extrinsic_variables: Optional[conlist(StrictStr)] = Field(None, description="External treatment (e.g. reagent).")
    intrinsic_variables: Optional[conlist(StrictStr)] = Field(None, description="Intrinsic (e.g. genetic) alteration.")
    __properties = ["@context", "attributes", "annotations_applied", "annotations", "uuid", "version", "model", "title", "organism_scientific_name", "organism_common_name", "organism_ncbi_taxon", "description", "biological_entity", "experimental_variables", "extrinsic_variables", "intrinsic_variables"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Biosample:
        """Create an instance of Biosample from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in annotations (list)
        _items = []
        if self.annotations:
            for _item in self.annotations:
                if _item:
                    _items.append(_item.to_dict())
            _dict['annotations'] = _items
        # override the default output from pydantic by calling `to_dict()` of model
        if self.model:
            _dict['model'] = self.model.to_dict()
        # set to None if model (nullable) is None
        # and __fields_set__ contains the field
        if self.model is None and "model" in self.__fields_set__:
            _dict['model'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Biosample:
        """Create an instance of Biosample from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Biosample.parse_obj(obj)

        _obj = Biosample.parse_obj({
            "context": obj.get("@context") if obj.get("@context") is not None else 'https://raw.githubusercontent.com/BioImage-Archive/bia-integrator/main/api/src/models/jsonld/1.0/SpecimenContext.jsonld',
            "attributes": obj.get("attributes"),
            "annotations_applied": obj.get("annotations_applied") if obj.get("annotations_applied") is not None else False,
            "annotations": [BiosampleAnnotation.from_dict(_item) for _item in obj.get("annotations")] if obj.get("annotations") is not None else None,
            "uuid": obj.get("uuid"),
            "version": obj.get("version"),
            "model": ModelMetadata.from_dict(obj.get("model")) if obj.get("model") is not None else None,
            "title": obj.get("title"),
            "organism_scientific_name": obj.get("organism_scientific_name"),
            "organism_common_name": obj.get("organism_common_name"),
            "organism_ncbi_taxon": obj.get("organism_ncbi_taxon"),
            "description": obj.get("description"),
            "biological_entity": obj.get("biological_entity"),
            "experimental_variables": obj.get("experimental_variables"),
            "extrinsic_variables": obj.get("extrinsic_variables"),
            "intrinsic_variables": obj.get("intrinsic_variables")
        })
        return _obj


